Break up format->part function into part_start and part_content functions.
[notmuch] / test / test-lib.sh
1 #!/usr/bin/env bash
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # if --tee was passed, write the output not only to the terminal, but
27 # additionally to the file test-results/$BASENAME.out, too.
28 case "$GIT_TEST_TEE_STARTED, $* " in
29 done,*)
30         # do not redirect again
31         ;;
32 *' --tee '*|*' --va'*)
33         mkdir -p test-results
34         BASE=test-results/$(basename "$0" .sh)
35         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
36          echo $? > $BASE.exit) | tee $BASE.out
37         test "$(cat $BASE.exit)" = 0
38         exit
39         ;;
40 esac
41
42 # Keep the original TERM for say_color
43 ORIGINAL_TERM=$TERM
44
45 # For repeatability, reset the environment to known value.
46 LANG=C
47 LC_ALL=C
48 PAGER=cat
49 TZ=UTC
50 TERM=dumb
51 export LANG LC_ALL PAGER TERM TZ
52 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
53
54 # Protect ourselves from common misconfiguration to export
55 # CDPATH into the environment
56 unset CDPATH
57
58 unset GREP_OPTIONS
59
60 # Convenience
61 #
62 # A regexp to match 5 and 40 hexdigits
63 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
64 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
65
66 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
67 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
68
69 # Each test should start with something like this, after copyright notices:
70 #
71 # test_description='Description of this test...
72 # This test checks if command xyzzy does the right thing...
73 # '
74 # . ./test-lib.sh
75 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
76                 TERM=$ORIGINAL_TERM &&
77                 export TERM &&
78                 [ -t 1 ] &&
79                 tput bold >/dev/null 2>&1 &&
80                 tput setaf 1 >/dev/null 2>&1 &&
81                 tput sgr0 >/dev/null 2>&1
82         ) &&
83         color=t
84
85 while test "$#" -ne 0
86 do
87         case "$1" in
88         -d|--d|--de|--deb|--debu|--debug)
89                 debug=t; shift ;;
90         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
91                 immediate=t; shift ;;
92         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
93                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
94         -h|--h|--he|--hel|--help)
95                 help=t; shift ;;
96         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
97                 verbose=t; shift ;;
98         -q|--q|--qu|--qui|--quie|--quiet)
99                 quiet=t; shift ;;
100         --with-dashes)
101                 with_dashes=t; shift ;;
102         --no-color)
103                 color=; shift ;;
104         --no-python)
105                 # noop now...
106                 shift ;;
107         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
108                 valgrind=t; verbose=t; shift ;;
109         --tee)
110                 shift ;; # was handled already
111         --root=*)
112                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
113                 shift ;;
114         *)
115                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
116         esac
117 done
118
119 if test -n "$color"; then
120         say_color () {
121                 (
122                 TERM=$ORIGINAL_TERM
123                 export TERM
124                 case "$1" in
125                         error) tput bold; tput setaf 1;; # bold red
126                         skip)  tput bold; tput setaf 2;; # bold green
127                         pass)  tput setaf 2;;            # green
128                         info)  tput setaf 3;;            # brown
129                         *) test -n "$quiet" && return;;
130                 esac
131                 shift
132                 printf " "
133                 printf "$@"
134                 tput sgr0
135                 )
136         }
137 else
138         say_color() {
139                 test -z "$1" && test -n "$quiet" && return
140                 shift
141                 printf " "
142                 printf "$@"
143         }
144 fi
145
146 error () {
147         say_color error "error: $*\n"
148         GIT_EXIT_OK=t
149         exit 1
150 }
151
152 say () {
153         say_color info "$*"
154 }
155
156 test "${test_description}" != "" ||
157 error "Test script did not set test_description."
158
159 if test "$help" = "t"
160 then
161         echo "Tests ${test_description}"
162         exit 0
163 fi
164
165 echo $(basename "$0"): "Testing ${test_description}"
166
167 exec 5>&1
168
169 test_failure=0
170 test_count=0
171 test_fixed=0
172 test_broken=0
173 test_success=0
174
175 die () {
176         code=$?
177         if test -n "$GIT_EXIT_OK"
178         then
179                 exit $code
180         else
181                 echo >&5 "FATAL: Unexpected exit with code $code"
182                 exit 1
183         fi
184 }
185
186 GIT_EXIT_OK=
187 trap 'die' EXIT
188
189 test_decode_color () {
190         sed     -e 's/.\[1m/<WHITE>/g' \
191                 -e 's/.\[31m/<RED>/g' \
192                 -e 's/.\[32m/<GREEN>/g' \
193                 -e 's/.\[33m/<YELLOW>/g' \
194                 -e 's/.\[34m/<BLUE>/g' \
195                 -e 's/.\[35m/<MAGENTA>/g' \
196                 -e 's/.\[36m/<CYAN>/g' \
197                 -e 's/.\[m/<RESET>/g'
198 }
199
200 q_to_nul () {
201         perl -pe 'y/Q/\000/'
202 }
203
204 q_to_cr () {
205         tr Q '\015'
206 }
207
208 append_cr () {
209         sed -e 's/$/Q/' | tr Q '\015'
210 }
211
212 remove_cr () {
213         tr '\015' Q | sed -e 's/Q$//'
214 }
215
216 # Notmuch helper functions
217 increment_mtime_amount=0
218 increment_mtime ()
219 {
220     dir="$1"
221
222     increment_mtime_amount=$((increment_mtime_amount + 1))
223     touch -d "+${increment_mtime_amount} seconds" "$dir"
224 }
225
226 # Generate a new message in the mail directory, with a unique message
227 # ID and subject. The message is not added to the index.
228 #
229 # After this function returns, the filename of the generated message
230 # is available as $gen_msg_filename and the message ID is available as
231 # $gen_msg_id .
232 #
233 # This function supports named parameters with the bash syntax for
234 # assigning a value to an associative array ([name]=value). The
235 # supported parameters are:
236 #
237 #  [dir]=directory/of/choice
238 #
239 #       Generate the message in directory 'directory/of/choice' within
240 #       the mail store. The directory will be created if necessary.
241 #
242 #  [filename]=name
243 #
244 #       Store the message in file 'name'. The default is to store it
245 #       in 'msg-<count>', where <count> is three-digit number of the
246 #       message.
247 #       
248 #  [body]=text
249 #
250 #       Text to use as the body of the email message
251 #
252 #  '[from]="Some User <user@example.com>"'
253 #  '[to]="Some User <user@example.com>"'
254 #  '[subject]="Subject of email message"'
255 #  '[date]="RFC 822 Date"'
256 #
257 #       Values for email headers. If not provided, default values will
258 #       be generated instead.
259 #
260 #  '[cc]="Some User <user@example.com>"'
261 #  [reply-to]=some-address
262 #  [in-reply-to]=<message-id>
263 #  [references]=<message-id>
264 #  [content-type]=content-type-specification
265 #  '[header]=full header line, including keyword'
266 #
267 #       Additional values for email headers. If these are not provided
268 #       then the relevant headers will simply not appear in the
269 #       message.
270 #
271 #  '[id]=message-id'
272 #
273 #       Controls the message-id of the created message.
274 gen_msg_cnt=0
275 gen_msg_filename=""
276 gen_msg_id=""
277 generate_message ()
278 {
279     # This is our (bash-specific) magic for doing named parameters
280     local -A template="($@)"
281     local additional_headers
282
283     gen_msg_cnt=$((gen_msg_cnt + 1))
284     if [ -z "${template[filename]}" ]; then
285         gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
286     else
287         gen_msg_name=${template[filename]}
288     fi
289
290     if [ -z "${template[id]}" ]; then
291         gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
292     else
293         gen_msg_id="${template[id]}"
294     fi
295
296     if [ -z "${template[dir]}" ]; then
297         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
298     else
299         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
300         mkdir -p "$(dirname "$gen_msg_filename")"
301     fi
302
303     if [ -z "${template[body]}" ]; then
304         template[body]="This is just a test message (#${gen_msg_cnt})"
305     fi
306
307     if [ -z "${template[from]}" ]; then
308         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
309     fi
310
311     if [ -z "${template[to]}" ]; then
312         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
313     fi
314
315     if [ -z "${template[subject]}" ]; then
316         template[subject]="Test message #${gen_msg_cnt}"
317     fi
318
319     if [ -z "${template[date]}" ]; then
320         template[date]="Tue, 05 Jan 2001 15:43:57 -0000"
321     fi
322
323     additional_headers=""
324     if [ ! -z "${template[header]}" ]; then
325         additional_headers="${template[header]}
326 ${additional_headers}"
327     fi
328
329     if [ ! -z "${template[reply-to]}" ]; then
330         additional_headers="Reply-To: ${template[reply-to]}
331 ${additional_headers}"
332     fi
333
334     if [ ! -z "${template[in-reply-to]}" ]; then
335         additional_headers="In-Reply-To: ${template[in-reply-to]}
336 ${additional_headers}"
337     fi
338
339     if [ ! -z "${template[cc]}" ]; then
340         additional_headers="Cc: ${template[cc]}
341 ${additional_headers}"
342     fi
343
344     if [ ! -z "${template[references]}" ]; then
345         additional_headers="References: ${template[references]}
346 ${additional_headers}"
347     fi
348
349     if [ ! -z "${template[content-type]}" ]; then
350         additional_headers="Content-Type: ${template[content-type]}
351 ${additional_headers}"
352     fi
353
354     # Note that in the way we're setting it above and using it below,
355     # `additional_headers' will also serve as the header / body separator
356     # (empty line in between).
357
358     cat <<EOF >"$gen_msg_filename"
359 From: ${template[from]}
360 To: ${template[to]}
361 Message-Id: <${gen_msg_id}>
362 Subject: ${template[subject]}
363 Date: ${template[date]}
364 ${additional_headers}
365 ${template[body]}
366 EOF
367
368     # Ensure that the mtime of the containing directory is updated
369     increment_mtime "$(dirname "${gen_msg_filename}")"
370 }
371
372 # Generate a new message and add it to the database.
373 #
374 # All of the arguments and return values supported by generate_message
375 # are also supported here, so see that function for details.
376 add_message ()
377 {
378     generate_message "$@" &&
379     notmuch new > /dev/null
380 }
381
382 # Generate a corpus of email and add it to the database.
383 #
384 # This corpus is fixed, (it happens to be 50 messages from early in
385 # the history of the notmuch mailing list), which allows for reliably
386 # testing commands that need to operate on a not-totally-trivial
387 # number of messages.
388 add_email_corpus ()
389 {
390     rm -rf ${MAIL_DIR}
391     if [ -d ../corpus.mail ]; then
392         cp -a ../corpus.mail ${MAIL_DIR}
393     else
394         cp -a ../corpus ${MAIL_DIR}
395         notmuch new >/dev/null
396         cp -a ${MAIL_DIR} ../corpus.mail
397     fi
398 }
399
400 test_begin_subtest ()
401 {
402     if [ -n "$inside_subtest" ]; then
403         exec 1>&6 2>&7          # Restore stdout and stderr
404         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
405     fi
406     test_subtest_name="$1"
407     # Remember stdout and stderr file descriptios and redirect test
408     # output to the previously prepared file descriptors 3 and 4 (see
409     # below)
410     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
411     exec 6>&1 7>&2 >&3 2>&4
412     inside_subtest=t
413 }
414
415 # Pass test if two arguments match
416 #
417 # Note: Unlike all other test_expect_* functions, this function does
418 # not accept a test name. Instead, the caller should call
419 # test_begin_subtest before calling this function in order to set the
420 # name.
421 test_expect_equal ()
422 {
423         exec 1>&6 2>&7          # Restore stdout and stderr
424         inside_subtest=
425         test "$#" = 3 && { prereq=$1; shift; } || prereq=
426         test "$#" = 2 ||
427         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
428
429         output="$1"
430         expected="$2"
431         if ! test_skip "$@"
432         then
433                 if [ "$output" = "$expected" ]; then
434                         test_ok_ "$test_subtest_name"
435                 else
436                         testname=$this_test.$test_count
437                         echo "$expected" > $testname.expected
438                         echo "$output" > $testname.output
439                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
440                 fi
441     fi
442 }
443
444 test_expect_equal_failure ()
445 {
446         exec 1>&6 2>&7          # Restore stdout and stderr
447         inside_subtest=
448         test "$#" = 3 && { prereq=$1; shift; } || prereq=
449         test "$#" = 2 ||
450         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
451
452         output="$1"
453         expected="$2"
454         if ! test_skip "$@"
455         then
456                 if [ "$output" = "$expected" ]; then
457                         test_known_broken_ok_ "$test_subtest_name"
458                 else
459                         test_known_broken_failure_ "$test_subtest_name"
460                         testname=$this_test.$test_count
461                         echo "$expected" > $testname.expected
462                         echo "$output" > $testname.output
463                 fi
464     fi
465 }
466
467 NOTMUCH_NEW ()
468 {
469     notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
470 }
471
472 notmuch_search_sanitize ()
473 {
474     sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
475 }
476
477 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
478 notmuch_show_sanitize ()
479 {
480     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
481 }
482
483 # End of notmuch helper functions
484
485 # Use test_set_prereq to tell that a particular prerequisite is available.
486 # The prerequisite can later be checked for in two ways:
487 #
488 # - Explicitly using test_have_prereq.
489 #
490 # - Implicitly by specifying the prerequisite tag in the calls to
491 #   test_expect_{success,failure,code}.
492 #
493 # The single parameter is the prerequisite tag (a simple word, in all
494 # capital letters by convention).
495
496 test_set_prereq () {
497         satisfied="$satisfied$1 "
498 }
499 satisfied=" "
500
501 test_have_prereq () {
502         case $satisfied in
503         *" $1 "*)
504                 : yes, have it ;;
505         *)
506                 ! : nope ;;
507         esac
508 }
509
510 # You are not expected to call test_ok_ and test_failure_ directly, use
511 # the text_expect_* functions instead.
512
513 test_ok_ () {
514         test_success=$(($test_success + 1))
515         say_color pass "%-6s" "PASS"
516         echo " $@"
517 }
518
519 test_failure_ () {
520         test_failure=$(($test_failure + 1))
521         say_color error "%-6s" "FAIL"
522         echo " $1"
523         shift
524         echo "$@" | sed -e 's/^/        /'
525         if test "$verbose" != "t"; then cat test.output; fi
526         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
527 }
528
529 test_known_broken_ok_ () {
530         test_fixed=$(($test_fixed+1))
531         say_color pass "%-6s" "FIXED"
532         echo " $@"
533 }
534
535 test_known_broken_failure_ () {
536         test_broken=$(($test_broken+1))
537         say_color pass "%-6s" "BROKEN"
538         echo " $@"
539 }
540
541 test_debug () {
542         test "$debug" = "" || eval "$1"
543 }
544
545 test_run_ () {
546         test_cleanup=:
547         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
548         eval >&3 2>&4 "$1"
549         eval_ret=$?
550         eval >&3 2>&4 "$test_cleanup"
551         return 0
552 }
553
554 test_skip () {
555         test_count=$(($test_count+1))
556         to_skip=
557         for skp in $NOTMUCH_SKIP_TESTS
558         do
559                 case $this_test.$test_count in
560                 $skp)
561                         to_skip=t
562                 esac
563         done
564         if test -z "$to_skip" && test -n "$prereq" &&
565            ! test_have_prereq "$prereq"
566         then
567                 to_skip=t
568         fi
569         case "$to_skip" in
570         t)
571                 say_color skip >&3 "skipping test: $@"
572                 say_color skip "%-6s" "SKIP"
573                 echo " $1"
574                 : true
575                 ;;
576         *)
577                 false
578                 ;;
579         esac
580 }
581
582 test_expect_failure () {
583         test "$#" = 3 && { prereq=$1; shift; } || prereq=
584         test "$#" = 2 ||
585         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
586         if ! test_skip "$@"
587         then
588                 test_run_ "$2"
589                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
590                 then
591                         test_known_broken_ok_ "$1"
592                 else
593                         test_known_broken_failure_ "$1"
594                 fi
595         fi
596 }
597
598 test_expect_success () {
599         test "$#" = 3 && { prereq=$1; shift; } || prereq=
600         test "$#" = 2 ||
601         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
602         if ! test_skip "$@"
603         then
604                 test_run_ "$2"
605                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
606                 then
607                         test_ok_ "$1"
608                 else
609                         test_failure_ "$@"
610                 fi
611         fi
612 }
613
614 test_expect_code () {
615         test "$#" = 4 && { prereq=$1; shift; } || prereq=
616         test "$#" = 3 ||
617         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
618         if ! test_skip "$@"
619         then
620                 test_run_ "$3"
621                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
622                 then
623                         test_ok_ "$2"
624                 else
625                         test_failure_ "$@"
626                 fi
627         fi
628 }
629
630 # test_external runs external test scripts that provide continuous
631 # test output about their progress, and succeeds/fails on
632 # zero/non-zero exit code.  It outputs the test output on stdout even
633 # in non-verbose mode, and announces the external script with "* run
634 # <n>: ..." before running it.  When providing relative paths, keep in
635 # mind that all scripts run in "trash directory".
636 # Usage: test_external description command arguments...
637 # Example: test_external 'Perl API' perl ../path/to/test.pl
638 test_external () {
639         test "$#" = 4 && { prereq=$1; shift; } || prereq=
640         test "$#" = 3 ||
641         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
642         descr="$1"
643         shift
644         if ! test_skip "$descr" "$@"
645         then
646                 # Announce the script to reduce confusion about the
647                 # test output that follows.
648                 say_color "" " run $test_count: $descr ($*)"
649                 # Run command; redirect its stderr to &4 as in
650                 # test_run_, but keep its stdout on our stdout even in
651                 # non-verbose mode.
652                 "$@" 2>&4
653                 if [ "$?" = 0 ]
654                 then
655                         test_ok_ "$descr"
656                 else
657                         test_failure_ "$descr" "$@"
658                 fi
659         fi
660 }
661
662 # Like test_external, but in addition tests that the command generated
663 # no output on stderr.
664 test_external_without_stderr () {
665         # The temporary file has no (and must have no) security
666         # implications.
667         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
668         stderr="$tmp/git-external-stderr.$$.tmp"
669         test_external "$@" 4> "$stderr"
670         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
671         descr="no stderr: $1"
672         shift
673         if [ ! -s "$stderr" ]; then
674                 rm "$stderr"
675                 test_ok_ "$descr"
676         else
677                 if [ "$verbose" = t ]; then
678                         output=`echo; echo Stderr is:; cat "$stderr"`
679                 else
680                         output=
681                 fi
682                 # rm first in case test_failure exits.
683                 rm "$stderr"
684                 test_failure_ "$descr" "$@" "$output"
685         fi
686 }
687
688 # This is not among top-level (test_expect_success | test_expect_failure)
689 # but is a prefix that can be used in the test script, like:
690 #
691 #       test_expect_success 'complain and die' '
692 #           do something &&
693 #           do something else &&
694 #           test_must_fail git checkout ../outerspace
695 #       '
696 #
697 # Writing this as "! git checkout ../outerspace" is wrong, because
698 # the failure could be due to a segv.  We want a controlled failure.
699
700 test_must_fail () {
701         "$@"
702         test $? -gt 0 -a $? -le 129 -o $? -gt 192
703 }
704
705 # test_cmp is a helper function to compare actual and expected output.
706 # You can use it like:
707 #
708 #       test_expect_success 'foo works' '
709 #               echo expected >expected &&
710 #               foo >actual &&
711 #               test_cmp expected actual
712 #       '
713 #
714 # This could be written as either "cmp" or "diff -u", but:
715 # - cmp's output is not nearly as easy to read as diff -u
716 # - not all diff versions understand "-u"
717
718 test_cmp() {
719         $GIT_TEST_CMP "$@"
720 }
721
722 # This function can be used to schedule some commands to be run
723 # unconditionally at the end of the test to restore sanity:
724 #
725 #       test_expect_success 'test core.capslock' '
726 #               git config core.capslock true &&
727 #               test_when_finished "git config --unset core.capslock" &&
728 #               hello world
729 #       '
730 #
731 # That would be roughly equivalent to
732 #
733 #       test_expect_success 'test core.capslock' '
734 #               git config core.capslock true &&
735 #               hello world
736 #               git config --unset core.capslock
737 #       '
738 #
739 # except that the greeting and config --unset must both succeed for
740 # the test to pass.
741
742 test_when_finished () {
743         test_cleanup="{ $*
744                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
745 }
746
747 test_done () {
748         GIT_EXIT_OK=t
749         test_results_dir="$TEST_DIRECTORY/test-results"
750         mkdir -p "$test_results_dir"
751         test_results_path="$test_results_dir/${0%.sh}-$$"
752
753         echo "total $test_count" >> $test_results_path
754         echo "success $test_success" >> $test_results_path
755         echo "fixed $test_fixed" >> $test_results_path
756         echo "broken $test_broken" >> $test_results_path
757         echo "failed $test_failure" >> $test_results_path
758         echo "" >> $test_results_path
759
760         echo
761
762         if [ "$test_failure" = "0" ]; then
763             if [ "$test_broken" = "0" ]; then       
764                 rm -rf "$remove_tmp"
765             fi
766             exit 0
767         else
768             exit 1
769         fi
770 }
771
772 test_emacs () {
773         # Construct a little test script here for the benefit of the user,
774         # (who can easily run "run_emacs" to get the same emacs environment
775         # for investigating any failures).    
776         cat <<EOF > run_emacs
777 #!/bin/sh
778 export PATH=$PATH
779 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
780
781 # We assume that the user will give a command-line argument only if
782 # wanting to run in batch mode.
783 if [ \$# -gt 0 ]; then
784         BATCH=--batch
785 fi
786
787 # Here's what we are using here:
788 #
789 # --batch:              Quit after given commands and print all (messages)
790 #
791 # --no-init-file        Don't load users ~/.emacs
792 #
793 # --no-site-file        Don't load the site-wide startup stuff
794 #
795 # --directory           Ensure that the local elisp sources are found
796 #
797 # --load                Force loading of notmuch.el and test-lib.el
798 #
799 # notmuch-test-wait     Function for tests to use to wait for process completion
800 #
801 # message-signature     Avoiding appending user's signature on messages
802 #
803 # set-frame-width       80 columns (avoids crazy 10-column default of --batch)
804
805 emacs \$BATCH --no-init-file --no-site-file \
806         --directory ../../emacs --load notmuch.el \
807         --directory .. --load test-lib.el \
808         --eval "(defun notmuch-test-wait ()
809                         (while (get-buffer-process (current-buffer))
810                                 (sleep-for 0.1)))" \
811         --eval "(setq message-signature nil)" \
812         --eval "(progn (set-frame-width (window-frame (get-buffer-window)) 80) \$@)"
813 EOF
814         chmod a+x ./run_emacs
815         ./run_emacs "$@"
816 }
817
818
819 find_notmuch_path ()
820 {
821     dir="$1"
822
823     while [ -n "$dir" ]; do
824         bin="$dir/notmuch"
825         if [ -x "$bin" ]; then
826             echo "$dir"
827             return
828         fi
829         dir="$(dirname "$dir")"
830         if [ "$dir" = "/" ]; then
831             break
832         fi
833     done
834 }
835
836 # Test the binaries we have just built.  The tests are kept in
837 # test/ subdirectory and are run in 'trash directory' subdirectory.
838 TEST_DIRECTORY=$(pwd)
839 if test -n "$valgrind"
840 then
841         make_symlink () {
842                 test -h "$2" &&
843                 test "$1" = "$(readlink "$2")" || {
844                         # be super paranoid
845                         if mkdir "$2".lock
846                         then
847                                 rm -f "$2" &&
848                                 ln -s "$1" "$2" &&
849                                 rm -r "$2".lock
850                         else
851                                 while test -d "$2".lock
852                                 do
853                                         say "Waiting for lock on $2."
854                                         sleep 1
855                                 done
856                         fi
857                 }
858         }
859
860         make_valgrind_symlink () {
861                 # handle only executables
862                 test -x "$1" || return
863
864                 base=$(basename "$1")
865                 symlink_target=$TEST_DIRECTORY/../$base
866                 # do not override scripts
867                 if test -x "$symlink_target" &&
868                     test ! -d "$symlink_target" &&
869                     test "#!" != "$(head -c 2 < "$symlink_target")"
870                 then
871                         symlink_target=../valgrind.sh
872                 fi
873                 case "$base" in
874                 *.sh|*.perl)
875                         symlink_target=../unprocessed-script
876                 esac
877                 # create the link, or replace it if it is out of date
878                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
879         }
880
881         # override notmuch executable in TEST_DIRECTORY/..
882         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
883         mkdir -p "$GIT_VALGRIND"/bin
884         make_valgrind_symlink $TEST_DIRECTORY/../notmuch
885         OLDIFS=$IFS
886         IFS=:
887         for path in $PATH
888         do
889                 ls "$path"/notmuch 2> /dev/null |
890                 while read file
891                 do
892                         make_valgrind_symlink "$file"
893                 done
894         done
895         IFS=$OLDIFS
896         PATH=$GIT_VALGRIND/bin:$PATH
897         GIT_EXEC_PATH=$GIT_VALGRIND/bin
898         export GIT_VALGRIND
899 else # normal case
900         notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
901         test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
902 fi
903 export PATH
904
905 # Test repository
906 test="tmp.$(basename "$0" .sh)"
907 test -n "$root" && test="$root/$test"
908 case "$test" in
909 /*) TMP_DIRECTORY="$test" ;;
910  *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
911 esac
912 test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
913 rm -fr "$test" || {
914         GIT_EXIT_OK=t
915         echo >&5 "FATAL: Cannot prepare test area"
916         exit 1
917 }
918
919 MAIL_DIR="${TMP_DIRECTORY}/mail"
920 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
921
922 mkdir -p "${test}"
923 mkdir -p "${MAIL_DIR}"
924
925 cat <<EOF >"${NOTMUCH_CONFIG}"
926 [database]
927 path=${MAIL_DIR}
928
929 [user]
930 name=Notmuch Test Suite
931 primary_email=test_suite@notmuchmail.org
932 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
933 EOF
934
935
936 # Use -P to resolve symlinks in our working directory so that the cwd
937 # in subprocesses like git equals our $PWD (for pathname comparisons).
938 cd -P "$test" || error "Cannot setup test environment"
939
940 if test "$verbose" = "t"
941 then
942         exec 4>&2 3>&1
943 else
944         exec 4>test.output 3>&4
945 fi
946
947 this_test=${0##*/}
948 for skp in $NOTMUCH_SKIP_TESTS
949 do
950         to_skip=
951         for skp in $NOTMUCH_SKIP_TESTS
952         do
953                 case "$this_test" in
954                 $skp)
955                         to_skip=t
956                 esac
957         done
958         case "$to_skip" in
959         t)
960                 say_color skip >&3 "skipping test $this_test altogether"
961                 say_color skip "skip all tests in $this_test"
962                 test_done
963         esac
964 done
965
966 # Provide an implementation of the 'yes' utility
967 yes () {
968         if test $# = 0
969         then
970                 y=y
971         else
972                 y="$*"
973         fi
974
975         while echo "$y"
976         do
977                 :
978         done
979 }
980
981 # Fix some commands on Windows
982 case $(uname -s) in
983 *MINGW*)
984         # Windows has its own (incompatible) sort and find
985         sort () {
986                 /usr/bin/sort "$@"
987         }
988         find () {
989                 /usr/bin/find "$@"
990         }
991         sum () {
992                 md5sum "$@"
993         }
994         # git sees Windows-style pwd
995         pwd () {
996                 builtin pwd -W
997         }
998         # no POSIX permissions
999         # backslashes in pathspec are converted to '/'
1000         # exec does not inherit the PID
1001         ;;
1002 *)
1003         test_set_prereq POSIXPERM
1004         test_set_prereq BSLASHPSPEC
1005         test_set_prereq EXECKEEPSPID
1006         ;;
1007 esac
1008
1009 test -z "$NO_PERL" && test_set_prereq PERL
1010 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1011
1012 # test whether the filesystem supports symbolic links
1013 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1014 rm -f y